//
//  TextStatsViewController.m
//  Attributor Multiple MVCs
//
//  Created by Sameh Fakhouri on 10/5/16.
//  Copyright © 2016 Sameh Fakhouri. All rights reserved.
//

#import "TextStatsViewController.h"

@interface TextStatsViewController ()
@property (weak, nonatomic) IBOutlet UILabel *colorfulCharactersLabel;
@property (weak, nonatomic) IBOutlet UILabel *outlinedCharactersLabel;

@end

@implementation TextStatsViewController

- (void)setTextToAnalyze:(NSAttributedString *)textToAnalyze
{
    _textToAnalyze = textToAnalyze;
    if (self.view.window) {
        [self updateUI];
    }
}



- (void)updateUI
{
    NSUInteger colorfulCharacters = [[self charactersWithAttribute:NSForegroundColorAttributeName] length];
    self.colorfulCharactersLabel.text = [NSString stringWithFormat:@"%d Colorful Characters", (int)colorfulCharacters];
    
    NSUInteger outlinedCharacters = [[self charactersWithAttribute:NSStrokeWidthAttributeName] length];
    self.outlinedCharactersLabel.text = [NSString stringWithFormat:@"%d Outlined Characters", (int)outlinedCharacters];
}



- (NSAttributedString *)charactersWithAttribute: (NSString *)attributeName
{
    NSMutableAttributedString *characters = [[NSMutableAttributedString alloc] init];
    
    NSUInteger index = 0;
    while (index < [self.textToAnalyze length]) {
        NSRange range;
        id value = [self.textToAnalyze attribute:attributeName
                                         atIndex:index
                                  effectiveRange:&range];
        if (value) {
            [characters appendAttributedString:[self.textToAnalyze
                                                attributedSubstringFromRange:range]];
            index = range.location + range.length;
        } else {
            index++;
        }
    }
    
    return characters;
}



- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self updateUI];
}


- (void)viewDidLoad
{
    [super viewDidLoad];
/*    self.textToAnalyze = [[NSAttributedString alloc] initWithString:@"my test" attributes:@{NSForegroundColorAttributeName:[UIColor greenColor],NSStrokeWidthAttributeName:@-3}];
*/
}


































@end
